<?php

namespace App\ViewModels\Pet\PetRegistrationViewModel;
use App\Utils\Builder;
use App\Utils\ResponseException;
use Config\CustomRules;
use Exception;

class PetRegistrationViewModelBuilder implements Builder
{
    protected $nome;
    protected $foto;
    protected $data_nascimento;
    protected $cor;
    protected $sexo;
    protected $castrado;
    protected $numero_chip;
    protected $rga_pedigree;
    protected $doado;
    protected $id_raca;
    protected $id_pet_status;
    protected $id_cliente;
    protected $observacoes;
    protected $porte;
    protected $peso;

    /**
     * @param mixed $observacoes
     * @return PetRegistrationViewModelBuilder
     */
    public function setObservacoes($observacoes)
    {
        $this->observacoes = $observacoes;
        return $this;
    }

    /**
     * @param mixed $porte
     * @return PetRegistrationViewModelBuilder
     */
    public function setPorte($porte)
    {
        $this->porte = $porte;
        return $this;
    }

    /**
     * @param mixed $id_pet_status
     * @return PetRegistrationViewModelBuilder
     */
    public function setIdPetStatus($id_pet_status)
    {
        $this->id_pet_status = $id_pet_status;
        return $this;
    }

    /**
     * @param mixed $foto
     * @return PetRegistrationViewModelBuilder
     */
    public function setFoto($foto)
    {
        $this->foto = $foto;
        return $this;
    }
    
    /**
     * @param mixed $foto
     * @return PetRegistrationViewModelBuilder
     */
    public function setNome($nome)
    {
        $this->nome = $nome;
        return $this;
    }

    /**
     * @param mixed $data_nascimento
     * @return PetRegistrationViewModelBuilder
     */
    public function setDataNascimento($data_nascimento)
    {
        $this->data_nascimento = $data_nascimento;
        return $this;
    }

    /**
     * @param mixed $cor
     * @return PetRegistrationViewModelBuilder
     */
    public function setCor($cor)
    {
        $this->cor = $cor;
        return $this;
    }

    /**
     * @param mixed $sexo
     * @return PetRegistrationViewModelBuilder
     */
    public function setSexo($sexo)
    {
        $this->sexo = $sexo;
        return $this;
    }

    /**
     * @param mixed $castrado
     * @return PetRegistrationViewModelBuilder
     */
    public function setCastrado($castrado)
    {
        $this->castrado = $castrado;
        return $this;
    }

    /**
     * @param mixed $numero_chip
     * @return PetRegistrationViewModelBuilder
     */
    public function setNumeroChip($numero_chip)
    {
        $this->numero_chip = $numero_chip;
        return $this;
    }

    /**
     * @param mixed $rga_pedigree
     * @return PetRegistrationViewModelBuilder
     */
    public function setRgaPedigree($rga_pedigree)
    {
        $this->rga_pedigree = $rga_pedigree;
        return $this;
    }

    /**
     * @param mixed $doado
     * @return PetRegistrationViewModelBuilder
     */
    public function setDoado($doado)
    {
        $this->doado = $doado;
        return $this;
    }

    /**
     * @param mixed $id_raca
     * @return PetRegistrationViewModelBuilder
     */
    public function setIdRaca($id_raca)
    {
        $this->id_raca = $id_raca;
        return $this;
    }

    /**
     * @param mixed $id_especie
     * @return PetRegistrationViewModelBuilder
     */
    public function setIdEspecie($id_especie)
    {
        $this->id_especie = $id_especie;
        return $this;
    }

    /**
     * @param mixed $id_cliente
     * @return PetRegistrationViewModelBuilder
     */
    public function setIdCliente($id_cliente)
    {
        $this->id_cliente = $id_cliente;
        return $this;
    }
    
    public function setPeso($peso)
    {
        $this->peso = $peso;
        return $this;
    }


    public function build () {
        $pet_registration_view_model = new PetRegistrationViewModel();
        $pet_registration_view_model->setDataNascimento($this->data_nascimento);
        $pet_registration_view_model->setIdRaca($this->id_raca);
        $pet_registration_view_model->setCor($this->cor);
        $pet_registration_view_model->setIdPetStatus($this->id_pet_status);
        $pet_registration_view_model->setSexo($this->sexo);
        $pet_registration_view_model->setCastrado($this->castrado);
        $pet_registration_view_model->setNumeroChip($this->numero_chip);
        $pet_registration_view_model->setRgaPedigree($this->rga_pedigree);
        $pet_registration_view_model->setDoado($this->doado);
        $pet_registration_view_model->setFoto($this->foto);
        $pet_registration_view_model->setIdCliente($this->id_cliente);
        $pet_registration_view_model->setNome($this->nome);
        $pet_registration_view_model->setPorte($this->porte);
        $pet_registration_view_model->setObservacoes($this->observacoes);
        $pet_registration_view_model->setPeso($this->peso);
        return $pet_registration_view_model;
    }
}
